﻿package {
	
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.filesystem.File;
	import flash.filesystem.FileMode;
	import flash.filesystem.FileStream;
	import flash.net.URLVariables;
	
	public class Main extends MovieClip {
		
		private var file:File;
		private var stream:FileStream;
		
		public function Main() {
			savePreferences();
		}
		
		private function savePreferences():void {
			file = File.documentsDirectory.resolvePath("prefs.txt");
			stream = new FileStream();
			stream.addEventListener(IOErrorEvent.IO_ERROR, ioError);
			stream.addEventListener(Event.CLOSE, fileSaved);
			stream.openAsync(file, FileMode.WRITE);
			stream.writeUTFBytes("music_vol=0.5&sound_vol=0.7&difficulty=easy");
			stream.close();
		}
		
		private function loadPreferences():void {
			file = File.documentsDirectory.resolvePath("prefs.txt");
			stream = new FileStream();
			stream.addEventListener(IOErrorEvent.IO_ERROR, ioError);
			stream.addEventListener(Event.COMPLETE, fileLoaded);
			stream.openAsync(file, FileMode.READ);
		}
		
		private function ioError(e:IOErrorEvent):void {
			output.appendText(e.errorID + ": " + e.text);
		}
		
		private function fileSaved(e:Event):void {
			output.appendText("Plik został zapisany \n");
			loadPreferences();
		}
		
		private function fileLoaded(e:Event):void {
			var prefs:String = stream.readUTFBytes(stream.bytesAvailable);
			stream.close();
						
			var vars:URLVariables = new URLVariables(prefs);
			output.appendText(
				"Wczytany plik\n" +
				"music volume: " + vars.music_vol  + "\n" +
				"sound volume: " + vars.sound_vol  + "\n" +
				"difficulty: "   + vars.difficulty + "\n"
			);
		}
	}
}
