#!/bin/sh
# This bash script will run on Mac OS X with the AIR SDK installed.
#
# Before running this script do the following:
# Replace <username> with your own personal username.
# Replace <p12_filename> with the name (including .p12 file extension) of your P12 certificate.
# Replace <p12_password> with the password you associated with your P12 certificate.

ADT="/Users/<username>/Applications/AdobeAIRSDK/bin/adt"
TARGET=ipa-test
PROV_FILE=~/Documents/packt/flash-ios-cookbook/developer-files/Flash_iOS_Cookbook.mobileprovision
CERT_FILE=~/Documents/packt/flash-ios-cookbook/developer-files/<p12_filename>
PASSWORD=<p12_password>
OUTPUT_IPA=render-test-gpu.ipa
APP_DESC_FILE=render-test-gpu-app.xml
SRC_FILES=render-test-gpu.swf

"$ADT" -package -target $TARGET -provisioning-profile $PROV_FILE -storetype pkcs12 -keystore $CERT_FILE -storepass $PASSWORD $OUTPUT_IPA $APP_DESC_FILE $SRC_FILES

